function X = HADGA(H,E12)
% INPUT
% H: affinity tensor
% E12

itermax = 50;
alpha = 0.01*1/itermax;
nCandMatch = length(H);
Hq = eye(nCandMatch);

Xpp = 1/nCandMatch * ones(nCandMatch,1);
Xp = 1/nCandMatch * ones(nCandMatch,1);

iter = 0;
while 1
    iter = iter + 1;
    X = tensorProduct(H,Xp);
    X = discretize(X,E12);
    
    if iter>itermax
        return;
    end
    if isequal_(X,Xp)
        return;
    elseif isequal_(X,Xpp)
        H = H + alpha*Hq;
    end
    Xpp = Xp;
    Xp = X;
end

end

function Xd = discretize(Xc,E12)
%     Xd = hungarian(Xc);
    Xd = zeros(size(E12)); Xd(find(E12)) = Xc;
    Xd = discretisationMatching_hungarian(Xd,E12); Xd = Xd(find(E12));
end

function b = isequal_(x1,x2)
    b = isequal(logical(x1),logical(x2));
end

function Y = tensorProduct(H,X)
    Y = H*X;
end