%% Integer Projected Fixed Point Method
% by Jungmin Lee in CVL
function X = IPFP( M, E12 )
%% Step 1: initialize
[n1 n2] = size( E12 );
% [L12(:,1) L12(:,2)] = find( E12 );

% randIdx = randperm(n2);
% randIdx = randIdx(1:n1);
% X = zeros(n1,n2);
% for i = 1:n1
%     X(i,randIdx(i)) = 1;
% end
% X = X(:);
% X = zeros(n1*n2,1);
X = ones(n1*n2,1)/n2;
X_answer = X;
% x = randperm(n2);
% x = [(1:n1)' x(1:n1)'];
% X(x(:,1)+(x(:,2)-1)*n1) = 1;
S = X'*M*X;
k = 0;

%% Step 2
while 1
    B = discretisationMatching_hungarian(reshape(M*X,n1,n2),E12);
    B = B(:);
    C = X'*M*(B-X);
    D = (B-X)'*M*(B-X);
    
    %% Step 3
    if D >= 0
        X2 = B;
    else
        r = min(-C/D, 1);
        X2 = X+r*(B-X);
    end
    
    %% Step 4
    if B'*M*B >= S
        S = B'*M*B;
        X_answer = B;
    end
    
    %% Step 5
    if sum(X2 - X) == 0 || k > 100
        if k == 100
            disp('Exception! in IPFP!')
        end
        break
    end
    
    %% Step 6
    k = k+1;
    X = X2;
end

%% Return the solution
X = reshape(X_answer, n1, n2);

from1to2 = sum(X,2);
from2to1 = sum(X,1);

if ~isempty(find(from1to2 > 1)) || ~isempty(find(from2to1 > 1))
	X = reshape(B, n1, n2);
end

end
