%% Makes current problem into Graph Matching form
function [X Xraw] = TBMA(affinityMatrix, group1, group2) %initX removed

% Make function evaluation script
%str = ['feval(@' func2str(method.fhandle)];
%for j = 1:length(method.variable), str = [str ',cdata.' method.variable{j} ]; end
%if ~isempty(method.param), for i = 1:length(method.param), str = [str, ',method.param{' num2str(i) '}']; end; end
%str = [str, ')']; 
% Function evaluation & Excution time Check
%tic; Xraw = eval(str); time = toc;

aff=affinityMatrix;
group1=group1;
group2=group2;

%how many multiple graphs we have %%v %b%
m=length(aff)/length(group1); %b%
graphSize=length(group1); %b%

nodesNum=length(aff);

%output to fill in with matching
X=zeros(nodesNum,1);

time=0;
%assigned not make an error
Xraw=X;



%% 4 TS/MA


%maxaff=max(max(aff));
%aff(aff<0.8*maxaff)=0;

% eliminate conflicting elements to prevent conflicting walks
for i=1:m
    i1=graphSize*(i-1); i2=graphSize*i; j1=graphSize*(i-1); j2=graphSize*i;
    aff(i1+1:i2,j1+1:j2) = aff(i1+1:i2,j1+1:j2).*~full(getConflictMatrix(group1, group2));
    aff(i1+1:i2,j1+1:j2) = aff(i1+1:i2,j1+1:j2)-6*full(getConflictMatrix(group1, group2)); %KEY nxn
end
%mam2=aff;
%save mam2.mat;

numNode=length(aff);
kNodes=sqrt(nodesNum);  %%v%%
q=20; %number of solutions/local optima


solutions=zeros(q,kNodes,2);
solutionsSum=zeros(q,1);
noUpdates=0;
maxAllScore=0;
maxAllPermO=zeros(1,numNode);


%population initialization
for iq=1:q

%(1) random
permO=randperm(kNodes); %KEY 

%(2) random constrained
% permO=zeros(1,k);
% for io=1:numNode/k
%     permO(io)=k*(io-1)+ceil(k*rand());
% end;

%random permutation to fill randomly the nodes in the clique to those in
%the intersection
%and to fill in the rest of the 380 spaces
 randPerm=randperm(nodesNum);
 Z=setxor(randPerm, permO); %I
 permO=[permO(1:kNodes) Z]; %I
 permO(1:kNodes);

%%%

[maxPermO maxPermContr maxWeightsSum]=tabu3(aff, permO, kNodes);

if maxWeightsSum>maxAllScore
    maxAllScore=maxWeightsSum; %VI
    maxAllPermO=maxPermO;
end

%solutions(iq, :)=sort(maxPermO(1:k));
solutions(iq,:, :)=maxPermContr;
solutionsSum(iq)=sum(solutions(iq,:, 2))/2;
iq=iq+1;



end %for q
solutionsSet=sort(solutions(:,:, 1),2) %VIMP
[solutionsSumSorted solutionsSumInd]=sort(solutionsSum);
save solutionsSet.mat
save solutionsSum.mat

x = 0:.1:1;
A = [x; exp(x)];

fileID = fopen('exp.txt','w');
fprintf(fileID,'%6s %12s\n','x','exp(x)');
fprintf(fileID,'%6.2f %12.8f\n',A);
fclose(fileID);


fileId=fopen('solutions.txt','at')
ssol=sort(solutions, 2); ssol(:,:,1); %VIMP
fprintf(fileId, '\n After tabu \n');
fprintf(fileId, '%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n', ssol(:,:,1));
%fclose(fileId);


% while noUpdates<15 %while stop criteria is not satisfied
% 
% %find the common vertices among the solutions
% %fill in the rest
% permmO=conjunction(solutions, nodesNum, q);
% %and run tabu
% [maxPermO maxPermContr maxWeightsSum]=tabu(aff, permmO, k);
% 
% 
% % numElements=size(solutions,1)*size(solutions,2);
% % sort(reshape(solutions, numElements,1))
% % 
% % randPerm=randperm(q); %I
% % intersection=intersect(solutions(randPerm(1), :), solutions(randPerm(2), :));
% % 
% % %random permutation to fill randomly the nodes in the clique to those in
% % %the intersection
% % %and to fill in the rest of the 380 spaces
% %  randPerm=randperm(nodesNum);
% %  Z=setxor(randPerm, intersection); %I
% %  permmO=[intersection Z]; %I
% % 
% % [maxPermO maxPermContr maxWeightsSum]=tabu(aff, permmO, k);
% % 
% if maxWeightsSum>maxAllScore
%     maxAllScore=maxWeightsSum; %I
%     maxAllPermO=maxPermO;
% end
% 
% %population update, if the current solution is better than from any of the
% %current population
% if maxWeightsSum>solutionsSumSorted(1)+0.000001
%     solutions(solutionsSumInd(1), :, :)=maxPermContr;
%     solutionsSum(solutionsSumInd(1))=sum(maxPermContr(:,2))/2;
%     [solutionsSumSorted solutionsSumInd]=sort(solutionsSum);
%     noUpdates=0;
% else
%     noUpdates=noUpdates+1;
% end
%     
%     
% end;




%ground truth
%groundScore=cdata.GTbool(:)'*cdata.affinityMatrix*cdata.GTbool(:) %I
%gr=find(cdata.GTbool(:)>0.5)';
%visGroundMatch=[ceil(gr/20); subs(mod(gr,20), 0, 20)] %I

ssol=sort(solutions, 2); %VIMP
%fopen(fileId, 'at');
fprintf(fileId, '\n After memetic \n');
fprintf(fileId, '%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n', ssol(:,:,1));
fclose(fileId);


%ours
visOurMatch=[ceil(permO(1:kNodes)/20); subs(mod(permO(1:kNodes),20), 0, 20)]';%I
X=zeros(nodesNum,1);
X(maxAllPermO(1:kNodes))=1;
sort(maxAllPermO(1:kNodes)); %VIMP
%%%%%END        

% % Matching Score
% score = X'*cdata.affinityMatrix*X % objective score function
% if length(cdata.GTbool) ~= length(cdata.affinityMatrix)
%     accuracy = NaN; % Exception for no GT information
% else
%     %X is ours, cdata.GTbook is groundtruth
%     accuracy = (X(:)'*cdata.GTbool(:))/sum(cdata.GTbool)
% end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



end