function [maxPermO maxPermContr maxWeightsSum]=tabu(aff, permO, k)

%note:
%tabu doesn't change for multiple because we still retrieve one solution,
%it's just for multiple we hope to get one time ne graph solution, one time
%other graph.

%%% algorithm
cls=5; %PARAM
nodesNum=length(permO);
alphaO=zeros(nodesNum, 1); %sum of nodes inside the clique
moveGains = zeros(cls);
tabuVector=zeros(nodesNum);
aTabu=2; %PARAM
bTabu=4; %PARAM
tabuIters=zeros(nodesNum,1);
%sum we want to minimize, our f(x)
iter=0;
nonImpIter=0;
alpha=50;
bestTabu=-100000*ones(3,1);
bestNonTabu=-100000*ones(3,1);
maxPermO=permO;
maxPermContr=zeros(k,2);

%for each node calculate the sum of affinity values to those inside
% the clique (we don't need outside, it's not our objective)
for i=1:nodesNum
        alphaO(i)=sum(aff(i,permO(1:k)));
end;

%find the sum of the initial clique and make it maxsum for initialization
maxWeightsSum=sum(alphaO(permO(1:k)))/2; %I
weightsSum=sum(alphaO(permO(1:k)))/2;

while (nonImpIter<alpha)
%for iuu=1:25000    
    if i~=-100000
    
    %step 2
    %for each node in and out of clique compute sum values to the nodes in
    %clique (first row) and add indexes of each nodes (second row of inClique &
    %outClique)

    inClique= [alphaO(permO(1:k))'; permO(1:k)];
    outClique= [alphaO(permO(k+1:end))'; permO(k+1:end)];

    %sort from lowest to highest
    [sorted, ind]=sort(inClique(1,:));
    sortedInClique=inClique(:, ind);

    %sort from highest to lowest
    [sortedOut, indOut]=sort(outClique(1,:), 'descend'); 
    sortedOutClique=outClique(:, indOut);


    %step 3
    %compute move gains for top cls nodes from sortedInClique and sortedOutClique
    for i=1:cls
        for j=1:cls
        moveGains(i,j)=-sortedInClique(1,i)+sortedOutClique(1,j)-aff(sortedInClique(2,i), sortedOutClique(2,j));
        end
    end

    %only for information, see which move is the best
    columnsCls=zeros(cls*cls,3);
    for i=1:cls
        for j=1:cls
            columnsCls((i-1)*cls+j, 1)=moveGains(i,j);
            columnsCls((i-1)*cls+j, 2)=i;
            columnsCls((i-1)*cls+j, 3)=j;
        end;
    end

    [aa bb]=sort(columnsCls(:,1), 'descend');
    columnsClsB=columnsCls(bb,:);
    %end information



    %step 4
    for iii=1:cls
        for jjj=1:cls

        %i and j are node indices of top nodes from cls
        %iii and jjj are just numbers from 1 to cls
         i=sortedInClique(2,iii);
         j=sortedOutClique(2,jjj);

         if (tabuIters(i)>iter | tabuIters(j)>iter) & moveGains(iii,jjj)>bestTabu(1)
             bestTabu(1)=moveGains(iii,jjj);
             bestTabu(2)=i;
             bestTabu(3)=j;
         elseif tabuIters(i)<=iter & tabuIters(j)<=iter & moveGains(iii,jjj)>bestNonTabu(1)
             bestNonTabu(1)=moveGains(iii,jjj);   
             bestNonTabu(2)=i;
             bestNonTabu(3)=j;
         end

         if  (bestTabu(1) > bestNonTabu(1)) & (weightsSum+bestTabu(1)>maxWeightsSum)
             best=bestTabu(1);
             i=bestTabu(2);
             j=bestTabu(3);
         else    % can lower the objective
             best=bestNonTabu(1);
             i=bestNonTabu(2);
             j=bestNonTabu(3);
         end

        end;  
    end;

    %shows that tabu lists shrinks and expands
    aq = find(tabuIters>iter); %I
    [aq tabuIters(aq)]; %I
    [i j]; %I
    best; %I
    
    if i==-100000
        break;
    end
    %end information
    
    %line 12 algo 2
     
    %step 5
    %exchange the nodes 
     weightsSum=weightsSum+best; %I
     
     ii=find(permO==i);
     jj=find(permO==j);
     temp=permO(ii);
     permO(ii)=permO(jj);
     permO(jj)=temp;
     
     tabuIters(i)=ceil(aTabu+bTabu*rand())+iter;
     tabuIters(j)=ceil(aTabu+bTabu*rand())+iter;
    
     tabuIters;
     
    %step 6
    %update the weights after the change
      
    %inClique
    for ii=1:k % k is the length of the nodes desired in clique

        if ii==i
            %alphaO(ii)=-alphaO(i)+aff(i,j) %if in U are negative
            %alphaO(ii)=alphaO(i)-aff(i,j); %if in both U (and Z) are positive %incorrect first version tested first
            alphaO(ii)=alphaO(i)+aff(i,j); %if in both U (and Z) are positive %corrected version
        else
            alphaO(ii)=alphaO(ii)-aff(i,ii)+aff(j,ii); %if in both U (and Z) are positive
        end
    end;

    %outClique
    for ii=k+1:length(permO)
         if ii==j
            %alphaO(ii)=-alphaO(j)+aff(i,j) %if in U are negative
            alphaO(ii)=alphaO(j)-aff(i,j); %if in both U (and Z) are positive
        else
            alphaO(ii)=alphaO(ii)-aff(i,ii)+aff(j,ii); 
        end

    end;


    %should be equal
    sumAlphas=sum(alphaO(permO(1:k)))/2;
    weightsSum;
   %end information
    
    
    %step 7
    %update the maximum score of the current is bigger than pervious max
    if weightsSum>maxWeightsSum
        maxWeightsSum=weightsSum; %I
        maxPermO=permO;
        nonImpIter=0;
        
        tobesortedpermO=permO(1:k)';
        maxPermContr= [permO(1:k)'  alphaO(permO(1:k))]; 
        [a b]=sort(alphaO(permO(1:k)), 'descend');
        maxPermContr=[tobesortedpermO(b) a];
        
    else
        nonImpIter=nonImpIter+1; %I
    end
    
    iter=iter+1;  
    bestTabu=-100000*ones(3,1);
    bestNonTabu=-100000*ones(3,1);
end
iuu=iuu+1;
end; %end while iter
%to see

end

%REMOVED


%%%% or that (case 2)
%if we exchange all variables from cls
% E=ones(length(moveGains));
% 
% 
% %step 4
% 
% assignment = discretisationMatching_hungarian(moveGains, E);
% 
% %step 5 update aplhaO (delta) vector
% 
% %the index of a node in clique and out of clique to be exchganged
% %e.g. {1,2} and {2,1}
% [indexInClique, indexOutClique] = find(assignment>0.4)
% 
% %index of the node to be changed among all the nodes in the matrix
% %e.g. {8,5} and {4,6}
% indexInCliqueNode = sortedInClique(2, indexInClique)
% indexOutCliqueNode = sortedOutClique(2, indexOutClique)
%%%

%%%
    
% case 2   
% for clsvar=1:cls %the length list of nodes to be exchanged
%     i=indexInCliqueNode(clsvar)
%     j=indexOutCliqueNode(clsvar)
%%%
