%% Makes current problem into Graph Matching form
function [X Xsol Xraw] = TBMA(affinityMatrix, group1, group2) %initX removed

% Make function evaluation script
%str = ['feval(@' func2str(method.fhandle)];
%for j = 1:length(method.variable), str = [str ',cdata.' method.variable{j} ]; end
%if ~isempty(method.param), for i = 1:length(method.param), str = [str, ',method.param{' num2str(i) '}']; end; end
%str = [str, ')']; 
% Function evaluation & Excution time Check
%tic; Xraw = eval(str); time = toc;

aff=affinityMatrix;
group1=group1;
group2=group2;

%how many multiple graphs we have %%v
m=length(aff)/length(group1)
graphSize=length(group1);

nodesNum=length(aff);

%output to fill in with matching
X=zeros(nodesNum,1);
%assigned not make an error
Xraw=X;

time=0;




%% algorithm 1 - random
% row=0;
% for i=1:20
% a=ceil(20*rand());
% X(row*20+a)=1;
% row=row+1;
% end;




%% 4 TS/MA


%maxaff=max(max(aff));
%aff(aff<0.8*maxaff)=0;

% eliminate conflicting elements to prevent conflicting walks
% for i=1:m
%     i1=graphSize*(i-1); i2=graphSize*i; j1=graphSize*(i-1); j2=graphSize*i;
% aff(i1+1:i2,j1+1:j2) = aff(i1+1:i2,j1+1:j2).*~full(getConflictMatrix(group1, group2));
% aff(i1+1:i2,j1+1:j2) = aff(i1+1:i2,j1+1:j2)-0.5*full(getConflictMatrix(group1, group2)); %KEY nxn
% end

% eliminate conflicting elements to prevent conflicting walks
%(works left top and right down, the rest we don't care what values there are)
aff = aff.*~full(getConflictMatrix(group1, group2));
aff = aff-6*full(getConflictMatrix(group1, group2));


numNode=length(aff);
%MULTIPLE
k=sqrt(nodesNum/2);  %%v%%
%SINGLE
%k=sqrt(nodesNum);
%q=70; %number of solutions/local optima 


solutions=zeros(q,k,2);
solutionsSum=zeros(q,1);
noUpdates=0;
maxAllScore=0;
maxAllPermO=zeros(1,numNode);


%population initialization
for iq=1:q

%(1) random
randPerm=randperm(nodesNum);

%(2) random constrained
% permO=zeros(1,k);
% for io=1:numNode/k
%     permO(io)=k*(io-1)+ceil(k*rand());
% end;

%%%

[maxPermO maxPermContr maxWeightsSum]=tabu3(aff, randPerm, k);

if maxWeightsSum>maxAllScore
    maxAllScore=maxWeightsSum %I
    maxAllPermO=maxPermO;
end

%solutions(iq, :)=sort(maxPermO(1:k));
solutions(iq,:, :)=maxPermContr;
solutionsSum(iq)=sum(solutions(iq,:, 2))/2;
iq=iq+1;

end %for q


[solutionsSumSorted solutionsSumInd]=sort(solutionsSum);

%solutions: 1dim - number of solutions, 2dim - nodes inthe solution, eg.20
%3 dim - affinity values
fileId=fopen('solutions.txt','at');

%ordered - horizontally, sorted - vertically
%orderedsol is the same as solutions but within a solution the nodes are sorted
%for better visualization
orderedsol=sort(solutions, 2); %within one solution to see nodes in order 
orderedNodes=orderedsol(:,:,1); 
orderedNodeval=orderedsol(:,:,2); %but note that the orderedNodeval are not ordered as in orderedsol

%sorted solutions from the worst to the best
afterTabuNod= orderedNodes(fliplr(solutionsSumInd), :, :); %display
afterTabuVal= orderedNodeval(fliplr(solutionsSumInd), :, :); %display
afterTabu=zeros(size(orderedsol,1), size(orderedsol,2), size(orderedsol, 3));
afterTabu(:,:,1)=afterTabuNod; afterTabu(:,:,2)=afterTabuVal; %same as below
solutions(:,:,1)=afterTabuNod; solutions(:,:,2)=afterTabuVal; %same as above
solutionsSumSorted2=sum(solutions(:,:,2),2)/2; %should be the same as solutionsSunSorted2

fprintf(fileId, '\n After tabu \n');
fprintf(fileId, '%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n', orderedsol(:,:,1));
%fclose(fileId);

% %%%%MEMETIC
%
% while noUpdates<15 %while stop criteria is not satisfied
% 
% %find the common vertices among the solutions
% %fill in the rest
% permmO=conjunction(afterTabu, nodesNum, q);
% %and run tabu
% [maxPermO maxPermContr maxWeightsSum]=tabu(aff, permmO, k);
% maxWeightsSum
% 
% % numElements=size(solutions,1)*size(solutions,2);
% % sort(reshape(solutions, numElements,1))
% % 
% % randPerm=randperm(q); %I
% % intersection=intersect(solutions(randPerm(1), :), solutions(randPerm(2), :));
% % 
% % %random permutation to fill randomly the nodes in the clique to those in
% % %the intersection
% % %and to fill in the rest of the 380 spaces
% %  randPerm=randperm(nodesNum);
% %  Z=setxor(randPerm, intersection); %I
% %  permmO=[intersection Z]; %I
% % 
% % [maxPermO maxPermContr maxWeightsSum]=tabu(aff, permmO, k);
% % 
% if maxWeightsSum>maxAllScore
%     maxAllScore=maxWeightsSum; %I
%     maxAllPermO=maxPermO;
% end
% 
% %population update, if the current solution is better than from any of the
% %current population
% if maxWeightsSum>solutionsSumSorted(1)+0.000001
%     solutionsSumSorted(1)=maxWeightsSum
%     solutions(1,:,1)=maxPermContr(:,1);
%     solutions(1,:,2)=maxPermContr(:,2);
%     [solutionsSumSorted solutionsSumInd] =sort(solutionsSumSorted);
%     anna=solutions(:,:,1);
%     solutions(:,:,1)=anna(solutionsSumInd, :);
%     anna2=solutions(:,:,2);
%     solutions(:,:,2)=anna2(solutionsSumInd, :);
% else
%     noUpdates=noUpdates+1;
% end
%     
%     
% end;
%
%solutions(:,:,1)=sort(solutions(:,:,1), 2); 
%afterMemetic=solutions(:,:,1)
%afterMemeticVal=solutions(:,:,2)
%
%ground truth
%groundScore=cdata.GTbool(:)'*cdata.affinityMatrix*cdata.GTbool(:) %I
%gr=find(cdata.GTbool(:)>0.5)';
%visGroundMatch=[ceil(gr/20); subs(mod(gr,20), 0, 20)] %I
%
%fopen(fileId, 'at');
%fprintf(fileId, '\n After memetic \n');
%fprintf(fileId, '%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n', orderedsol(:,:,1));
%fclose(fileId);
%
%%%%%%%


%single best
X=zeros(nodesNum,1);
X(maxAllPermO(1:k))=1;

%information
maximumPermutation=sort(maxAllPermO(1:k))'
%

%multiple best
topSolutions=getTopSolutions(solutions, 2);
Xsol=zeros(nodesNum,2);
Xsol(topSolutions(1,:,1),1)=1; %%%v%%%
if sum(topSolutions(2,:,1))~=0
    Xsol(topSolutions(2,:,1),2)=1; %%%v%%%
end

%%%%%END        

% % Matching Score
% score = X'*cdata.affinityMatrix*X % objective score function
% if length(cdata.GTbool) ~= length(cdata.affinityMatrix)
%     accuracy = NaN; % Exception for no GT information
% else
%     %X is ours, cdata.GTbook is groundtruth
%     accuracy = (X(:)'*cdata.GTbool(:))/sum(cdata.GTbool)
% end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



end