%% Makes current problem into Graph Matching form
function [X Xraw] = TBMA(affinityMatrix, group1, group2) %initX removed

% Make function evaluation script
%str = ['feval(@' func2str(method.fhandle)];
%for j = 1:length(method.variable), str = [str ',cdata.' method.variable{j} ]; end
%if ~isempty(method.param), for i = 1:length(method.param), str = [str, ',method.param{' num2str(i) '}']; end; end
%str = [str, ')']; 
% Function evaluation & Excution time Check
%tic; Xraw = eval(str); time = toc;

aff=affinityMatrix;
group1=group1;
group2=group2;

nodesNum=length(aff);

%output to fill in with matching
X=zeros(nodesNum,1);

time=0;
%assigned not make an error
Xraw=X;



%% algorithm 1 - random
% row=0;
% for i=1:20
% a=ceil(20*rand());
% X(row*20+a)=1;
% row=row+1;
% end;

%% algorithm 2 - sum

% eliminate conflicting elements to prevent conflicting walks
%aff = aff.*~full(getConflictMatrix(group1, group2));
%aff = aff-100*full(getConflictMatrix(group1, group2));
%
% maxaff=max(max(aff));
% aff(aff<0.8*maxaff)=0;
% 
% %in the affinity matrix, sum the value for all 
% %the edges outgoing from the given node
% %the node in the affinity matrix corresponds to the pair of nodes
% %(that is matching between two nodes)
% %in the original affinity graph
% 
% %the idea is that the nodes which have high sum are likely to 
% %have strong connection to other leaders in the groups
% nodeSum=zeros(nodesNum,1);
% for i=1:nodesNum
%     for j=1:nodesNum
%         nodeSum(i)=nodeSum(i)+aff(i,j);
%     end;
% end;
% 
% nodeSum;
% 
% %sort nodes in a descending order
% [sorted indices]=sort(nodeSum, 'descend');
% 
% [indices sorted];
% 
% %get indices from number, e.g. 34 is (20,14)
% ind.a=ceil(indices/20);
% ind.b=mod(indices,20);
% ind.b=subs(ind.b, 0, 20);
% 
% all=[ind.a ind.b];
% 
% 
% X=zeros(nodesNum,1);
% 
% %choose the matching such that two nodes whose sum of affinity
% %values in the affinity matrix is the highest.
% %Continue and choose the matching if neither of the nodes 
% %from either of the graphs was matched before.
% 
% graphA=zeros(20,1);
% graphB=zeros(20,1);
% 
% for i=1:length(ind.a)
%     if graphA(ind.a(i))==0 && graphB(ind.b(i))==0
%         X(indices(i))=1;
%         graphA(ind.a(i))=1;
%         graphB(ind.b(i))=1;
%     end;
% end;

%% algorithm 2b enhance sum
%--the same as 2a
% eliminate conflicting elements to prevent conflicting walks
%aff = aff.*~full(getConflictMatrix(group1, group2));
%aff = aff-100*full(getConflictMatrix(group1, group2));
%
% maxaff=max(max(aff));
% aff(aff<0.8*maxaff)=0;

%in the affinity matrix, sum the value for all 
%the edges outgoing from the given node
%the node in the affinity matrix corresponds to the pair of nodes
%(that is matching between two nodes)
%in the original affinity graph

%the idea is that the nodes which have high sum are likely to 
%have strong connection to other leaders in the groups

%--the same as 2a

% partialnodesSum1=[];
% partialnodesInd1=[];
% 
% nodeSum=zeros(nodesNum,1);
% for i=1:nodesNum
%     for j=1:nodesNum
%         nodeSum(i)=nodeSum(i)+aff(i,j);
%     end;
%     if mod(i,20)==0
%         partialnodeSum=nodeSum(i-19:i);
%         [sorted indices]=sort(partialnodeSum, 'descend');
%         partialnodesSum1=[partialnodesSum1; sorted(1:3)];
%         partialnodesInd1=[partialnodesInd1; indices(1:3)];
%     end;
% end;

%% algorithm 3 - variable local search

%--the same as 2a
%maxaff=max(max(aff));
%aff(aff<0.8*maxaff)=0;

% eliminate conflicting elements to prevent conflicting walks
aff = aff.*~full(getConflictMatrix(group1, group2));
aff = aff-0.5*full(getConflictMatrix(group1, group2));


%in the affinity matrix, sum the value for all 
%the edges outgoing from the given node
%the node in the affinity matrix corresponds to the pair of nodes
%(that is matching between two nodes)
%in the original affinity graph

%the idea is that the nodes which have high sum are likely to 
%have strong connection to other leaders in the groups

%--the same as 2a

% k=20; %number of nodes to choose
% 
% itToEnd=000;
% itEndLocal=1000;
% 
% % choose permutation
% %(1) random
% permO=randperm(nodesNum);
% 
% 
% %(2) eigenvalue
% %for initialization compute eigen-vector
% options.disp = 0;
% [eigenVectorMat eigenValue] = eigs(aff, 1, 'lm', options); % EigenSolver
% eigenVector = eigenVectorMat(:,1); % Principal eigenvector
% Xraw = abs(eigenVector);
% 
%  % Hungarian assignment
%  X = zeros(size(cdata.E12)); X(find(cdata.E12)) = Xraw;
%  X = discretisationMatching_hungarian(X,cdata.E12); X = X(find(cdata.E12));
%  
%  
%  gr=find(X>0.5)';
%  % the match obtain from the initialized 
%  viseig=[ceil(gr/20); subs(mod(gr,20), 0, 20)];
%  
%  %0.4 is just a value, any value between 0 and 1 does the job to get the
%  %indices of those that have 1 from the X vector
%  %first 20 are the initialized solution of nodes (that is an edge in the
%  %original graph) from the affinity matrix
%  permO=[find(X>0.4); find(X<0.4)];
%  
% %(3) initialized from the given by algorithm
% 
%  gr=find(X>0.5)';
%  % the match obtain from the initialized 
%  visInitMatch=[ceil(gr/20); subs(mod(gr,20), 0, 20)]
% 
% permO=[find(initX>0.4); find(initX<0.4)];
 
 
%%% algorithm

% permC=permO;
% 
% p_cur=1;
% p_min=1;
% p_max=min([k nodesNum-k]);
% 
% alphaO=zeros(nodesNum, 1); %sum of nodes inside the clique
% betaO=zeros(nodesNum, 1); %sum of nodes outside of clique
% alphaC=zeros(nodesNum, 1); %sum of nodes inside the clique
% betaC=zeros(nodesNum, 1); %sum of nodes outside of clique
% 
% %for each node calculate the sum of affinity values to those inside
% %of the clique (we don't need outside, not our objective
% for i=1:nodesNum
%         alphaO(i)=sum(aff(i,permO(1:k)));
%         %betaO(i)=sum(aff(i,permO(k+1:nodesNum)));
% end;
% 
% %sum we want to minimize, our f(x)
% weightsSum=sum(alphaO(permO(1:k)))/2
% 
% 
% runtime=0;
% oldruntime=0;
% runtimeMax=20;
% tic
%while (iter<itToEnd)
% while (runtime<runtimeMax)
%     p_cur=p_min;
%     while(p_cur<p_max && iter<itToEnd)
%     while(p_cur<p_max && runtime<runtimeMax)
% 
%         delta=-1;
%         iter=iter+1;
%         if (mod(iter, 1000)==0)
%            iter
%         end;
%         SHAKING
%         choose indices from 1 to k and from k+1 to the end
%         cliquePerm=randperm(k);
%         outcliquePerm=k+randperm(nodesNum-k);
%         
%         iInd=cliquePerm(1:p_cur);
%         jInd=outcliquePerm(1:p_cur);
%        
%         permC=permO;
%         alphaC=alphaO;
% 
%         deltaShake=0;
%         for i=1:p_cur
%             
%  
%             
%             for x=1:nodesNum
%             alphaC(x)=alphaC(x)+aff(x,permC(jInd(i)))-aff(x,permC(iInd(i)));
%             betaC(x)=betaC(x)+aff(x,permC(iInd(i)))-aff(x,permC(jInd(i)));
%             end
%             
%             dsum=sum(aff(permC(jInd(i)),permC(1:k)))-sum(aff(permC(iInd(i)),permC(1:k)))-aff(permC(iInd(i)), permC(jInd(i)));
%             deltaShake=deltaShake+dsum
%             
%             zeswapowac po zsumowaniu po sie nie zgadza
%             toSwap=permC(iInd(i));
%             permC(iInd(i))=permC(jInd(i));
%             permC(jInd(i))=toSwap;
% 
%         end;
% 
%          SHAKING_END  
%          itl=0;
%          LOCAL_SEARCH
%         while(delta<0 && itl<itEndLocal)
%         itl=itl+1;
%             choose indices from 1 to k and from k+1 to the end
% 
%             iInd=ceil(k*rand());
%             jInd=k+ceil((nodesNum-k)*rand());
% 
%             delta=sum(aff(permC(jInd),permC(1:k)))-sum(aff(permC(iInd),permC(1:k)))-aff(permC(iInd), permC(jInd));
%         end;
%        
%         delta;
%         
%         for x=1:nodesNum
%             alphaC(x)=alphaC(x)+aff(x,permC(jInd))-aff(x,permC(iInd));
%             betaC(x)=betaC(x)+aff(x,permC(iInd))-aff(x,permC(jInd));
%         end
% 
%         toSwap=permC(iInd);
%         permC(iInd)=permC(jInd);
%         permC(jInd)=toSwap;
%         
%         weightsSumNew=sum(alphaC(permC(1:k)))/2;
%           LOCAL_SEARCH_END
% 
%         if (iter<itToEnd && weightsSumNew >weightsSum)
%         if (runtime<runtimeMax && weightsSumNew >weightsSum)
%             if (runtime-oldruntime>60  && runtime-oldruntime<200 && (weightsSumNew-weightsSum)/weightsSum<0.05)
%                 permO=randperm(nodesNum);
%                 runtime=0;
%                 oldruntime=0;
%                 %for each node calculate the sum of affinity values to those in and outside
%                 %of the clique
%                 for i=1:nodesNum
%                      alphaO(i)=sum(aff(i,permO(1:k)));
%                      betaO(i)=sum(aff(i,permO(k+1:nodesNum)));
%                 end;
% 
%                 %sum we want to minimize
%                 weightsSum=sum(alphaO(permO(1:k)))/2
%                 break;
%             end;
%             weightsSum=weightsSumNew
%             oldruntime=runtime
%             
%             permO=permC;
%             permO(1:20);
%             alphaO=alphaC;
%             betaO=betaC;
%         
%             p_cur=p_min;
%         else
%             p_cur=p_cur+1;
%         end;
%     
%     end;
%     
%    
% runtime=toc;
% end;

%sum of weights in the clique, that sum of every edge between the nodes 
%in the clique
%weightsSum

%% 4 TS/MA


%maxaff=max(max(aff));
%aff(aff<0.8*maxaff)=0;

% eliminate conflicting elements to prevent conflicting walks
aff = aff.*~full(getConflictMatrix(group1, group2));
aff = aff-0.5*full(getConflictMatrix(group1, group2)); %KEY nxn

numNode=length(aff);
k=sqrt(nodesNum); 
q=20; %number of solutions/local optima


solutions=zeros(q,k);
maxAllScore=0;
maxAllPermO=zeros(1,numNode);

for iq=1:q

%(1) random
permO=randperm(k); %KEY 

%(2) random constrained
% permO=zeros(1,k);
% for io=1:numNode/k
%     permO(io)=k*(io-1)+ceil(k*rand());
% end;

%random permutation to fill randomly the nodes in the clique to those in
%the intersection
%and to fill in the rest of the 380 spaces
 randPerm=randperm(nodesNum);
 Z=setxor(randPerm, permO); %I
 permO=[permO(1:k) Z]; %I
 permO(1:k);

%%%

[maxPermO maxPermContr maxWeightsSum]=tabu(aff, permO, k);

if maxWeightsSum>maxAllScore
    maxAllScore=maxWeightsSum %I
    maxAllPermO=maxPermO;
end

solutions(iq, :)=sort(maxPermO(1:k));
iq=iq+1;

%cs=5;
%memetic(maxPermContr, cs);

end %for q

numElements=size(solutions,1)*size(solutions,2);
sort(reshape(solutions, numElements,1))

randPerm=randperm(q); %I
intersection=intersect(solutions(randPerm(1), :), solutions(randPerm(2), :));

%random permutation to fill randomly the nodes in the clique to those in
%the intersection
%and to fill in the rest of the 380 spaces
 randPerm=randperm(nodesNum);
 Z=setxor(randPerm, intersection); %I
 permmO=[intersection Z]; %I

[maxPermO maxPermContr maxWeightsSum]=tabu(aff, permmO, k);

if maxWeightsSum>maxAllScore
    maxAllScore=maxWeightsSum; %I
    maxAllPermO=maxPermO;
end





%ground truth
%groundScore=cdata.GTbool(:)'*cdata.affinityMatrix*cdata.GTbool(:) %I
%gr=find(cdata.GTbool(:)>0.5)';
%visGroundMatch=[ceil(gr/20); subs(mod(gr,20), 0, 20)] %I

%ours
visOurMatch=[ceil(permO(1:k)/20); subs(mod(permO(1:k),20), 0, 20)]';%I
X=zeros(nodesNum,1);
X(maxAllPermO(1:k))=1;
sort(maxAllPermO(1:k))
%%%%%END        

% % Matching Score
% score = X'*cdata.affinityMatrix*X % objective score function
% if length(cdata.GTbool) ~= length(cdata.affinityMatrix)
%     accuracy = NaN; % Exception for no GT information
% else
%     %X is ours, cdata.GTbook is groundtruth
%     accuracy = (X(:)'*cdata.GTbool(:))/sum(cdata.GTbool)
% end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



end