function [maxPermO maxPermContr maxWeightsSum]=tabu(aff, permO, k)

%note:
%tabu doesn't change for multiple because we still retrieve one solution,
%it's just for multiple we hope to get one time ne graph solution, one time
%other graph.

%%% algorithm

cls=5; %PARAM
nodesNum=length(permO);
alphaO=zeros(nodesNum, 1); %sum of nodes inside the clique
moveGains = zeros(cls);
aTabu=2; %PARAM
bTabu=4; %PARAM
tabuIters=zeros(nodesNum,1);
%sum we want to minimize, our f(x)
iter=0;
nonImpIter=0;
alpha=1500;
bestTabu=-100000*ones(3,1);
bestNonTabu=-100000*ones(3,1);
secondBest=-100000*ones(3,1);
maxPermO=permO;
maxPermContr=zeros(k,2);




%for each node calculate the sum of affinity values to those inside
% the clique (we don't need outside, it's not our objective)
for i=1:nodesNum
        alphaO(i)=sum(aff(i,permO(1:k)));
end;

%find the sum of the initial clique and make it maxsum for initialization
maxWeightsSum=sum(alphaO(permO(1:k)))/2; %I
weightsSum=sum(alphaO(permO(1:k)))/2;

origweightsSum=weightsSum;
secondSolutions=[-10000000*ones(10, nodesNum) -1000000*ones(10, 1)] ;

while (nonImpIter<alpha)

    
    
%for iuu=1:25000    
    
    
    %step 2
    %for each node in and out of clique compute sum values to the nodes in
    %clique (first row) and add indexes of each nodes (second row of inClique &
    %outClique)

    inClique= [alphaO(permO(1:k))'; permO(1:k)];
    outClique= [alphaO(permO(k+1:end))'; permO(k+1:end)];

    %sort from lowest to highest
    [sorted, ind]=sort(inClique(1,:));
    sortedInClique=inClique(:, ind);

    %sort from highest to lowest
    [sortedOut, indOut]=sort(outClique(1,:), 'descend'); 
    sortedOutClique=outClique(:, indOut);


    %step 3
    %compute move gains for top cls nodes from sortedInClique and sortedOutClique
    for i=1:cls
        for j=1:cls
        moveGains(i,j)=-sortedInClique(1,i)+sortedOutClique(1,j)-aff(sortedInClique(2,i), sortedOutClique(2,j));
        end
    end

    %only for information, see which move is the best
    columnsCls=zeros(cls*cls,3);
    for i=1:cls
        for j=1:cls
            columnsCls((i-1)*cls+j, 1)=moveGains(i,j);
            columnsCls((i-1)*cls+j, 2)=i;
            columnsCls((i-1)*cls+j, 3)=j;
        end;
    end

    [aa bb]=sort(columnsCls(:,1), 'descend');
    columnsClsB=columnsCls(bb,:);
    %end information

    secondBest=-100000*ones(3,1);

    %step 4
    for iii=1:cls
        for jjj=1:cls

        %i and j are node indices of top nodes from cls
        %iii and jjj are just numbers from 1 to cls
         i=sortedInClique(2,iii);
         j=sortedOutClique(2,jjj);

         if (tabuIters(i)>iter | tabuIters(j)>iter) & moveGains(iii,jjj)>bestTabu(1)
             bestTabu(1)=moveGains(iii,jjj);
             bestTabu(2)=i;
             bestTabu(3)=j;
         elseif tabuIters(i)<=iter & tabuIters(j)<=iter 
             if moveGains(iii,jjj)>bestNonTabu(1)
             bestNonTabu(1)=moveGains(iii,jjj);   
             bestNonTabu(2)=i;
             bestNonTabu(3)=j;
             elseif moveGains(iii,jjj)>secondBest(1)
             secondBest(1)=moveGains(iii,jjj);
             secondBest(2)=i;
             secondBest(3)=j;
             end
         end

         if  (bestTabu(1) > bestNonTabu(1)) & (weightsSum+bestTabu(1)>maxWeightsSum)
             best=bestTabu(1);
             i=bestTabu(2);
             j=bestTabu(3);
             
             %since we'll use tabu, we'll take non-tabu as a backup
             secondBest(1)=bestNonTabu(1);
             secondBest(2)=bestNonTabu(2);
             secondBest(3)=bestNonTabu(3);
             
             
         else    % can lower the objective
             best=bestNonTabu(1);
             i=bestNonTabu(2);
             j=bestNonTabu(3);

             
         end

        end;  
    end;
    
    
   if secondBest(1)~=-100000
    %remember second solution
     permOsecond=permO; 
     
      %for each node in the clique calculate the sum of affinity values 
     %to those inside the clique 
%     secondObj=0;
% %      for u=1:k
% % %          sum(aff(permOsecond(u),permOsecond(1:k)));
% %         secondObj=secondObj+sum(aff(permOsecond(u),permOsecond(1:k)));
% %     end;
%     secondObj = sum(aff(permOsecond(1:k),permOsecond(1:k)));
%      secondObj=secondObj/2;
     
    sumAlphas2=sum(alphaO(permO(1:k)))/2;
    
     i2=find(permOsecond==secondBest(2));
     j2=find(permOsecond==secondBest(3));
     temp=permOsecond(i2);
     permOsecond(i2)=permOsecond(j2);
     permOsecond(j2)=temp;

     %for each node in the clique calculate the sum of affinity values 
     %to those inside the clique 
%     secondObj=0;
%      for v=1:k
% %          sum(aff(permOsecond(v),permOsecond(1:k)));
%         secondObj=secondObj+sum(aff(permOsecond(v),permOsecond(1:k)));
%     end;
%     secondObj=secondObj/2;
   end %end for second

    
    
    %shows that tabu lists shrinks and expands
    aq = find(tabuIters>iter); %I
    [aq tabuIters(aq)]; %I
    [i j]; %I
    best; %I
    
    %if i==-100000
    %    break;
    %end
    %end information
    
    %line 12 algo 2
    
    if i~=-100000 %| nonImpIter<3*alpha/4
    
    
     
    %step 5
    %exchange the nodes 
     origweightSum=weightsSum;
     weightsSum=weightsSum+best;%I
     
     ii=find(permO==i);
     jj=find(permO==j);
     temp=permO(ii);
     permO(ii)=permO(jj);
     permO(jj)=temp;
     
     %%%check
     permOsecond=permO; 
     
      %for each node in the clique calculate the sum of affinity values 
     %to those inside the clique 
%     secondObj=0;
%      for u=1:k
% %          sum(aff(permOsecond(u),permOsecond(1:k)));
%         secondObj=secondObj+sum(aff(permOsecond(u),permOsecond(1:k)));
%     end;
    secondObj = sum(sum( aff(permOsecond(1:k),permOsecond(1:k)) ));
%     assert(secondObj==secondObj_);
     secondObj=secondObj/2;
     %%%%
     %step 5b tabu
     
     tabuIters(i)=ceil(aTabu+bTabu*rand())+iter;
     tabuIters(j)=ceil(aTabu+bTabu*rand())+iter;
    
     tabuIters;
     
    %step 6
    %update the weights after the change
      
    % hacked by YUMIN
    
    alphaO_ = alphaO;
    b = false(size(alphaO));
    b(1:k) = true;
    alphaO_(b) = alphaO_(b)-aff(i,b)'+aff(j,b)';
    if 1<=i && i<=k
        alphaO_(i) = alphaO(i)+aff(i,j);
    end
    alphaO = alphaO_;
    %inClique
%     for ii=1:k % k is the length of the nodes desired in clique
% 
%         if ii==i
%             %alphaO(ii)=-alphaO(i)+aff(i,j) %if in U are negative
%             %alphaO(ii)=alphaO(i)-aff(i,j); %if in both U (and Z) are positive %incorrect first version tested first
%             alphaO(ii)=alphaO(i)+aff(i,j); %if in both U (and Z) are positive %corrected version
%         else
%             alphaO(ii)=alphaO(ii)-aff(i,ii)+aff(j,ii); %if in both U (and Z) are positive
%         end
%     end;
%     assert(all(alphaO==alphaO_));

    
    alphaO_ = alphaO;
    b = false(size(alphaO));
    b(k+1:length(permO)) = true;
    alphaO_(b) = alphaO_(b)-aff(i,b)'+aff(j,b)';
    if k+1<=j && j<=length(permO)
        alphaO_(j) = alphaO(j)-aff(i,j);
    end
    alphaO = alphaO_;
    %outClique
%     for ii=k+1:length(permO)
%          if ii==j
%             %alphaO(ii)=-alphaO(j)+aff(i,j) %if in U are negative
%             alphaO(ii)=alphaO(j)-aff(i,j); %if in both U (and Z) are positive
%         else
%             alphaO(ii)=alphaO(ii)-aff(i,ii)+aff(j,ii); 
%         end
% 
%     end;
%     assert(all(alphaO==alphaO_));

    %inClique
    %outClique
    % hacked by YUMIN - END

    %should be equal
    sumAlphas=sum(alphaO(permO(1:k)))/2;
    weightsSum;
   %end information
    
    
    %step 7
    %update the maximum score of the current is bigger than pervious max
    if weightsSum>(maxWeightsSum+0.0001)
        maxWeightsSum=weightsSum; %I
        maxPermO=permO;
        nonImpIter=0;
        
        tobesortedpermO=permO(1:k)';
        maxPermContr= [permO(1:k)'  alphaO(permO(1:k))]; 
        [a b]=sort(alphaO(permO(1:k)), 'descend');
        maxPermContr=[tobesortedpermO(b) a];
        
    else
        nonImpIter=nonImpIter+1; %I
    end
    
    %step 8 
    %secondsolutions
    %origweightSum is the weight of the permO (original permutation) before
    %exchange
    
    if secondObj>secondSolutions(1, nodesNum+1)
     
     secondSolutions(1, 1:nodesNum)=permOsecond;
     secondSolutions(1, nodesNum+1)=secondObj;
     secondSolutions=sortrows(secondSolutions, nodesNum+1);
        
    end
    secondSolutions(:, 1:k);
    secondSolutions(:, nodesNum+1);
    iter=iter+1;  
    bestTabu=-100000*ones(3,1);
    bestNonTabu=-100000*ones(3,1);
else
%iuu=iuu+1;

    
    permO=secondSolutions(end, 1:nodesNum);  

    %for each node calculate the sum of affinity values to those inside
    % the clique (we don't need outside, it's not our objective)
    for i=1:nodesNum
            alphaO(i)=sum(aff(i,permO(1:k)));
    end;

    %find the sum of the initial clique and make it maxsum for initialization
    weightsSum=sum(alphaO(permO(1:k)))/2;

    origweightsSum=weightsSum;
    tabuIters=iter*ones(nodesNum,1);
    bestTabu=-100000*ones(3,1);
    bestNonTabu=-100000*ones(3,1);


end  %end if teminatation conditio  

end; %end while iter
%to see

mamamama=7;

end

%REMOVED


%%%% or that (case 2)
%if we exchange all variables from cls
% E=ones(length(moveGains));
% 
% 
% %step 4
% 
% assignment = discretisationMatching_hungarian(moveGains, E);
% 
% %step 5 update aplhaO (delta) vector
% 
% %the index of a node in clique and out of clique to be exchganged
% %e.g. {1,2} and {2,1}
% [indexInClique, indexOutClique] = find(assignment>0.4)
% 
% %index of the node to be changed among all the nodes in the matrix
% %e.g. {8,5} and {4,6}
% indexInCliqueNode = sortedInClique(2, indexInClique)
% indexOutCliqueNode = sortedOutClique(2, indexOutClique)
%%%

%%%
    
% case 2   
% for clsvar=1:cls %the length list of nodes to be exchanged
%     i=indexInCliqueNode(clsvar)
%     j=indexOutCliqueNode(clsvar)
%%%
