function [X, Xraw] = TBMA_reproduce_yumin(aff, group1, group2)
% 2016/6/7 Yumin Suh

% parameters
penalty = 9;
nLocalMax = 20;

% variable initialization
nMatch = length(aff);
nNode = sqrt(nMatch);
maxSco = -inf;
maxMember = [];

% penalize association graph
aff = aff .* ~full(getConflictMatrix(group1, group2)) ...
    - penalty * full(getConflictMatrix(group1, group2));

for iLocalMax = 1 : nLocalMax
    
    member0 = randperm(nNode);
    Z = setxor(randperm(nMatch), member0);
    member0 = [member0, Z];
    
    [member, sco] = tabu_yumin_reproduce(aff, member0, nNode);
    
    if sco > maxSco
        maxSco = sco;
        maxMember = member;
    end
end

X = zeros(nMatch,1);
X(maxMember)=1;
Xraw = [];  % dummy