function [theMoveout, theMovein, movegain] = ...
    selectMoveInOut(moveGains, bTabuMoveout, bTabuMovein, curSco, maxSco)
% 2016/6/7 Yumin Suh

% INPUT
% moveGains: (nMoveout x nMoveout)

% old code
%     tic
%     tabuMask = logical(double(bTabuMoveout(:))*double(bTabuMovein(:))');
%     [iTabu,jTabu] = find(tabuMask);
%     [iNonTabu,jNonTabu] = find(~tabuMask);
%     tabus = moveGains(tabuMask);
%     [bestTabu,bestTabuIdx] = max(tabus(:));
%     nontabus = moveGains(~tabuMask);
%     [bestNonTabu,bestNonTabuIdx] = max(nontabus(:));
%     toc
% 
%     if ~isempty(bestTabu) && curSco+bestTabu > maxSco
%         theMoveout = iTabu(bestTabuIdx);
%         theMovein = jTabu(bestTabuIdx);
%         movegain = bestTabu;
%     else
%         if ~isempty(bestNonTabu)
%             theMoveout = iNonTabu(bestNonTabuIdx);
%             theMovein = jNonTabu(bestNonTabuIdx);
%             movegain = bestNonTabu;
%         else
%             theMoveout = nan;
%             theMovein = nan;
%             movegain = nan;
%         end
%     end
    
    
%     tic
    bestTabu = -inf;
    bestNonTabu = -inf;
%     bestTabuMoveout = [];
%     bestTabuMovein = [];
%     bestNonTabuMoveout = [];
%     bestNonTabuMovein = [];
    
    nSearchMoveout = size(moveGains,1);
    nSearchMovein = size(moveGains,2);
    for iMoveout = 1 : nSearchMoveout
        for iMovein = 1 : nSearchMovein
            movegain = moveGains(iMoveout,iMovein);
            % tabu
            if bTabuMoveout(iMoveout) || bTabuMovein(iMovein)
                if(movegain>bestTabu)
                    bestTabu = movegain;
                    bestTabuMoveout = iMoveout;
                    bestTabuMovein = iMovein;
                end
            % non-tabu
            else
                if(movegain>bestNonTabu)
                    bestNonTabu = movegain;
                    bestNonTabuMoveout = iMoveout;
                    bestNonTabuMovein = iMovein;
                end
            end
        end
    end
%     toc
    
    if ~isinf(bestTabu) && curSco+bestTabu > maxSco
        theMoveout = bestTabuMoveout;
        theMovein = bestTabuMovein;
        movegain = bestTabu;
    else
        if ~isinf(bestNonTabu)
            theMoveout = bestNonTabuMoveout;
            theMovein = bestNonTabuMovein;
            movegain = bestNonTabu;
        else
            theMoveout = nan;
            theMovein = nan;
            movegain = nan;
        end
    end

    
%     assert(bestTabuMoveout == iTabu(bestTabuIdx));
%     assert(bestTabuMovein == jTabu(bestTabuIdx));
%     assert(bestNonTabuMoveout == iNonTabu(bestNonTabuIdx));
%     assert(bestNonTabuMovein == jNonTabu(bestNonTabuIdx));
end