close all; clc;
disp('************************ Random Graph Matching Test ************************'); disp(' ');

%% Settings Evaluations
setPathTest;
%setPath; 
setRandomGraphTest; 
%setRandomGraph;
%SINGLE
setMethods
%MULTI
%setMethodsMulti;
%clear all when adding or removing methods

%%
plotSet.lineWidth = 3; % Line width
plotSet.markerSize = 10; % Marker Size
plotSet.fontSize = 20; % Font Size
plotSet.font = '\fontname{times new roman}'; % Font default

%for multiple change three things
%1.methods
%2. make graphmatchingproblem
%output of gmwrapper

%% Test Methods
%according to what we want (which parameters we want to vary) we put appropriate values
%into settings
%setting contains different settings of the experiemnt
%first number (Con) says the criteria
%1 - inliers, 2 - outliers, 3 - deformation noise, 4 - edge density
%in the first case (testing in deformation noise) deformation noise varies
%and others are constant
%the second paramter demienion and value 4 indicates the value that may
%vary
multiGraph=2;
Accuracy = zeros(length(settings{Con}{4}), length(methods), Set.nTest);
AccuracyMat = zeros(length(settings{Con}{4}), length(methods), Set.nTest, multiGraph);
MatchScore = zeros(length(settings{Con}{4}), length(methods), Set.nTest);
Time = zeros(length(settings{Con}{4}), length(methods), Set.nTest);

gt=fopen('solutions.txt','w')
fclose(gt);


t_start = clock;
fprintf(['Experiment starts: ' num2str(t_start(4)) ':' num2str(t_start(5)) ':' num2str(round(t_start(6))) '\n']);
%for each noise/outlier level (five of them, say) run each algorithm,
%repeat all n times
for kk = 1:Set.nTest, fprintf('Test: %d of %d ', kk, Set.nTest); %Set.nTest = 30, # iteratios of entire experiment
    for i = 1:length(settings{Con}{4}) %number of varied values, e.g. deformation, 0, 0.2, 0.4, 0.6, etc.
        noise=settings{Con}{4}(i)
        %fileId=fopen('solutions.txt','a');
        %fprintf(fileId, '\n%5.2f\n', settings{Con}{4}(i));
        %fclose(fileId);

        eval(['Set.' settings{Con}{3} '=' num2str(settings{Con}{4}(i)) ';']);
        %MULTIPLE
        %problem = makeMultipleGraphMatchingProblem(Set); %%v%%
        %save(sprintf('foldermult/mult_defVAR_out0_%02d_%02d.mat',kk, noise),'problem');
        %SINGLE
        problem = makeGraphMatchingProblem(Set); %%v%%
        %save(sprintf('folder/def0p1_out10_%02d_%02d.mat',kk, noise),'problem');
        %
        eval(['Set.' settings{Con}{3} '= settings{' num2str(Con) '}{4};']);
        for j = 1:length(methods)
            %kk - number of tests, i - number of values for noise, j -
            %algorithms
            %MULTIPLE
            %[Accuracy(i,j,kk) MatchScore(i,j,kk) Time(i,j,kk) gt gtscore AccuracyMat(i,j,kk,:)] = wrapper_GMmulti(methods(j), problem); %%v%%
            %SINGLE
            [Accuracy(i,j,kk) MatchScore(i,j,kk) Time(i,j,kk) X gtscore] = wrapper_GMcomp(methods(j), problem);
            %Xs{j}=X;
            %
        end
        fprintf('.');
        %X
        gtscore=gtscore/2
    end
    
   
    
    
    %MULTIPLE 
%     color=['r', 'b', 'g']
%     %for each graph in g2
%     clf; 
%     for i=1:problem.m
%     %clf; 
%     %clf; handleCount = 0; yData = mean(Accuracy(:,:,1:kk),3); yLabelText = 'Accuracy'; plotResults;
%     colorMulti=color(i);
%     %clf; 
%     handleCount = 0; yData = mean(AccuracyMat(:,:,1:kk,i),3); yLabelText = 'Accuracy'; 
%     plotResults;
%     end;
    
    %SINGLE
    clf; handleCount = 0; 
    yData = mean(Accuracy(:,:,1:kk),3); 
    yLabelText = 'Accuracy'; 
    plotResults;
    
    
    str = ['Average accuracy from test 1 to test ' num2str(kk)]; title(str, 'FontSize', 16); drawnow;
    t_now = clock; elap = etime(t_now, t_start); t_end = add_time(t_start, elap/(kk)*(Set.nTest));
    fprintf(['  expected time to end ' num2str(t_end(4)) ':' num2str(t_end(5)) ':' num2str(round(t_end(6))) '\n']);
end
%save folder/Accuracy;
%save foldermult/Accuracy;
clear i j kk temp X Xbin ind p val str
%close all


%% Plot Results
meanAccuracy = mean(Accuracy,3);
meanMatchScore = mean(MatchScore,3);
meanTime = mean(Time,3);

%%
%handleCount = 0;
yData = meanAccuracy; yLabelText = 'Accuracy'; plotResults;
yData = meanMatchScore; yLabelText = 'Objective score'; plotResults;
yData = meanTime; yLabelText = 'Time'; plotResults;