function [ problem ] = makeGraphMatchingProblem( Set )
%% Extract all variables from Set
strNames = fieldnames(Set);
for i = 1:length(strNames), eval([strNames{i} '= Set.' strNames{i} ';']); end
%% Set number of nodes
if bOutBoth, nP1 = nInlier + nOutlier; else nP1 = nInlier; end
nP2 = nInlier + nOutlier;
%% Generate two graphs
% GT sequence
if bPermute, seq = randperm(nP2); else seq = 1:nP2; end
% Generate graph 1 
G1 = tril(rand(nP1),-1); % lower triangular graph
G1 = G1+G1';
P = tril(rand(nP1),-1);
P = P+P';
P = P > ratioFill;
G1(P) = NaN;

N = deformation*tril(randn(nP2),-1);
N = N+N';

G2 = tril(rand(nP2),-1);
G2 = G2+G2';
P = tril(rand(nP2),-1);
P = P+P';
P = P > ratioFill;
G2(P) = NaN;
G2(seq(1:nInlier),seq(1:nInlier)) = G1(1:nInlier,1:nInlier);
G2 = G2+N;

E12 = ones(nP1,nP2);
[L12(:,1) L12(:,2)] = find(E12);
[group1 group2] = make_group12(L12);

M = (repmat(G1, nP2, nP2)-kron(G2,ones(nP1))).^2;
% M = 2 - M;
% M = abs((repmat(G1, nP2, nP2)-kron(G2,ones(nP1))));
% M_square = M.^2;
% M_lin = 1 - M_square;
% M_exp = exp(-M_square./scale_2D);

% M_lin(isnan(M_lin)) = 0;
% M_lin(1:(length(M_lin)+1):end)=0;
% M_lin = M_lin+M_lin';
% M_exp(isnan(M_exp)) = 0;
% M_exp(1:(length(M_exp)+1):end)=0;
% M_exp = M_exp+M_exp';

% M = (2 - M)/2;
% M(M<0)=0;
M = exp(-M./scale_2D);
% M = max(2-M,0);
M(isnan(M)) = 0;
M(1:(length(M)+1):end)=0;
M = M+M';
% TEST truncation
% M( M<0.2 ) = 0;



%%
% M = (repmat(G1, nP2, nP2)-kron(G2,ones(nP1))).^2;
M2 = repmat(G1, nP2, nP2).*kron(G2,ones(nP1));
% M = exp(-M./scale_2D);
M2(isnan(M2)) = 0;
M2(1:(length(M2)+1):end)=0;
M2 = (M2+M2')/2;

% eliminate conflicting elements to prevent conflicting walks
conf1 = zeros(size(M));
conf2 = zeros(size(M));
for i = 1:size(group1,2)
    idx = find(group1(:,i));
    for j = 1:length(idx)
        for k = 1:length(idx)
            conf1(idx(j),idx(k)) = 1;
        end
    end
end
for i = 1:size(group2,2)
    idx = find(group2(:,i));
    for j = 1:length(idx)
        for k = 1:length(idx)
            conf1(idx(j),idx(k)) = 1;
        end
    end
end
conf = conf1 | conf2;
M = M.*(~conf);

M2 = M2.*(~conf);


%% graph variables for Factorized Graph Matching
% edge map for fully connected graph
E1 = [];
for j = 1:length(G1)-1
    for i = j+1:length(G1)
        E1 = [E1; j i];
    end
end
E2 = [];
for j = 1:length(G2)-1
    for i = j+1:length(G2)
        E2 = [E2; j i];
    end
end
% construct node by edge relation map
H1 = zeros(length(G1), length(E1));
for i = 1:length(E1)
    H1(E1(i,1),i) = 1;
    H1(E1(i,2),i) = 1;
end
H2 = zeros(length(G2), length(E2));
for i = 1:length(E2)
    H2(E2(i,1),i) = 1;
    H2(E2(i,2),i) = 1;
end

Kp = zeros(nP1, nP2);
Kq = zeros(length(E1), length(E2));
Kq2 = zeros(length(E1), length(E2));
for j = 1:length(E1)
    e1 = G1(E1(j,1),E1(j,2));
    for i = 1:length(E2)
        e2 = G2(E2(i,1),E2(i,2));
        Kq(j,i) = exp(-((e1-e2)^2)/scale_2D);
        Kq2(j,i) = e1*e2;
%         Kq(j,i) = e1*e2;
    end
end



KPP = 0;
KQQ = zeros(size(E1,1),size(E2,1));
for i = 1 : size(E1,1)
    for j = 1 : size(E2,1)
        m1 = E1(i,1) + (E2(j,1)-1)*nP1;
        m2 = E1(i,2) + (E2(j,2)-1)*nP1;
        KQQ(i,j) = M(m1,m2)/2;
    end
end

for i = 1 : size(E1,1)
    for j = 1 : size(E2,1)
        m1 = E1(i,1) + (E2(j,1)-1)*nP1;
        m2 = E1(i,2) + (E2(j,2)-1)*nP1;
        MM(m1,m2) = Kq(i,j);
    end
end




% Kq
% M
% 
% unique(Kq(:))
% unique(M(:))
% 
% H1
% H2
L = [Kq -Kq*H2'; -H1*Kq H1*Kq*H2'];
L2 = [Kq2 -Kq2*H2'; -H1*Kq2 H1*Kq2*H2'];

gphs{1}.G = H1;
gphs{2}.G = H2;

H1 = [H1 eye(length(G1))];
H2 = [H2 eye(length(G2))];

gphs{1}.H = H1;
gphs{2}.H = H2;


%% SVD of Kq
nAdj = rank(L);
[U, S, V] = svd(L);
% diag(S)
% U(:,1:5)
% V(:,1:5)

U = U(:,1:nAdj);
V = V(:,1:nAdj);
for k = 1:nAdj
    U(:,k) = U(:,k)*sqrt(S(k,k));
    V(:,k) = V(:,k)*sqrt(S(k,k));
end

T = U(:,1)*V(:,1)';
for k = 2:nAdj
    T = T + U(:,k)*V(:,k)';
end
% T

%% new Adj matrix generation
for k = 1:nAdj
    A1{k} = H1*diag(U(:,k))*H1';
    A2{k} = H2*diag(V(:,k))*H2';
    
%     A1{k}(A1{k} < 0) = 0;
%     A2{k}(A2{k} < 0) = 0;
end

%% SVD of Kq
nAdj = rank(L2);
[U, S, V] = svd(L2);
% diag(S)
% U(:,1:5)
% V(:,1:5)

U = U(:,1:nAdj);
V = V(:,1:nAdj);
for k = 1:nAdj
    U(:,k) = U(:,k)*sqrt(S(k,k));
    V(:,k) = V(:,k)*sqrt(S(k,k));
end

T = U(:,1)*V(:,1)';
for k = 2:nAdj
    T = T + U(:,k)*V(:,k)';
end
% T

%% new Adj matrix generation
for k = 1:nAdj
    B1{k} = H1*diag(U(:,k))*H1';
    B2{k} = H2*diag(V(:,k))*H2';
    
%     A1{k}(A1{k} < 0) = 0;
%     A2{k}(A2{k} < 0) = 0;
end

% %% Validation
% while 0
% %     X = ones(size(A1{1},1), size(A2{1},1));
%     X = rand(size(A1{1},1), size(A2{1},1));
%     x = X(:);
%     
% %     S = 0;
% %     for k = 1:nAdj
% %         S = S + trace(A1{k}*X*A2{k}*X');
% %     end
% %     s = x'*M*x;
%     
%     [S s S/s]
%     pause
% end

% M = zeros(nP1*nP2);
% for j = 1:length(M)-1
%     for i = j+1:length(M)
%         if isnan( G1(L12(j,1),L12(i,1)) ) || isnan( G2(L12(j,2),L12(i,2)) )
%             M(j,i) = 0;
%         else
%             M(j,i) = exp(-(G1(L12(j,1),L12(i,1))-G2(L12(j,2),L12(i,2)))^2/scale_2D);
%         end
%     end
% end

% %% 3rd Order Tensor
% [i j k] = ind2sub([nP1 nP1 nP1], 1:nP1^3);
% G1 = rand(nP1,nP1,nP1);
% % G1 = ratioFill3D*rand(nP1,nP1,nP1)/0.3;
% G1(i>=j) = 0; G1(j>=k) = 0;
% P = rand(nP1,nP1,nP1);
% P(i>=j) = 0; P(j>=k) = 0;
% G1(P > ratioFill3D) = NaN;
% 
% tmp = find(~isnan(G1)&G1~=0);
% [t1(:,1) t1(:,2) t1(:,3)] = ind2sub([nP1 nP1 nP1],tmp);
% t1 = int32(t1'-1);
% feat1 = G1(G1>0)';
% 
% G1 = G1+permute(G1, [1 3 2])+permute(G1, [2 1 3])+permute(G1, [2 3 1])+permute(G1, [3 1 2])+permute(G1, [3 2 1]);
% G1(i==j) = NaN; G1(k==j) = NaN; G1(k==i) = NaN;
% 
% N = deformation*randn(nP2,nP2,nP2);
% N(i>=j) = 0; N(j>=k) = 0;
% N = N+permute(N, [1 3 2])+permute(N, [2 1 3])+permute(N, [2 3 1])+permute(N, [3 1 2])+permute(N, [3 2 1]);
% 
% G2 = rand(nP2,nP2,nP2);
% % G2 = ratioFill3D*rand(nP2,nP2,nP2)/0.3;
% G2(i>=j) = 0; G2(j>=k) = 0;
% P = rand(nP2,nP2,nP2);
% P(i>=j) = 0; P(j>=k) = 0;
% G2(P > ratioFill3D) = NaN;
% G2 = G2+permute(G2, [1 3 2])+permute(G2, [2 1 3])+permute(G2, [2 3 1])+permute(G2, [3 1 2])+permute(G2, [3 2 1]);
% G2(seq(1:nInlier),seq(1:nInlier),seq(1:nInlier)) = G1(1:nInlier,1:nInlier,1:nInlier);
% G2 = G2+N;
% 
% G2(isnan(G2))= -10;
% feat2 = G2(:)';
% 
% % G1
% % G2
% % pause
% 
% %generate features
% % t1=int32(t1);
% % [feat1,feat2] = mexComputeFeature(P1',P2',int32(t1),'simple');
% 
% %number of nearest neighbors used for each triangle (results can be bad if too low)
% nT = length(feat1);
% nNN = min(nnz(G2),500);
% % nNN=nT;
% 
% %find the nearest neighbors
% [inds, dists] = annquery(feat2, feat1, nNN, 'eps', 10);
% 
% %build the tensor
% [i j k]=ind2sub([nP2,nP2,nP2],inds);
% tmp=repmat(1:nT,nNN,1);
% 
% indH3 = t1(:,tmp(:))' + [k(:)-1 j(:)-1 i(:)-1]*nP1;
% valH3 = exp(-dists(:)/scale_3D);

%% Ground Truth
GT.seq = seq(1:nInlier);
GT.matrix = zeros(nP1, nP2);
for i = 1:nInlier, GT.matrix(i,seq(i)) = 1; end
GT.bool = GT.matrix(:);

%% Return results
problem.nP1 = nP1;
problem.nP2 = nP2;
problem.G1 = G1;
problem.G2 = G2;

problem.E12 = E12;
problem.L12 = L12;
problem.affinityMatrix = M;
problem.productMatrix = M2;
problem.group1 = group1;
problem.group2 = group2;

% problem.H1 = H1;
% problem.H2 = H2;
% problem.Kp = zeros(nP1, nP2);
% problem.Kq = Kq;

problem.H1 = H1;
problem.H2 = H2;
problem.Kp = Kp;
problem.Kq = Kq;
problem.Kq2 = Kq2;
problem.gphs = gphs;
problem.asgT = [];

par.nAlp = 100;
par.nItMa = 100;
par.nHst = 10;
par.ip = 'y';
par.thAlp = 0;
par.deb = 'n';
par.idxAlp = [];
problem.par = par;

problem.A1 = A1;
problem.A2 = A2;
problem.B1 = B1;
problem.B2 = B2;

% problem.tensor_idx = indH3;
% problem.affinityTensor = valH3;
% problem.tensor_idx_full = indH3;

problem.GTbool = GT.bool;

% S = getS_disc(M,GT.matrix(:),nP1,nP2);
% MS = M.*repmat(S,nP2,nP2);

% M = zeros(nP1*nP2);
% for j = 1:length(M)-1
%     for i = j+1:length(M)
%         if isnan( G1(L12(j,1),L12(i,1)) ) || isnan( G2(L12(j,2),L12(i,2)) )
%             M(j,i) = 0;
%         else
%             M(j,i) = exp(-(G1(L12(j,1),L12(i,1))-G2(L12(j,2),L12(i,2)))^2/scale_2D);
%         end
%     end
% end

%% 3rd Order Tensor
% [i j k] = ind2sub([nP1 nP1 nP1], 1:nP1^3);
% G1 = rand(nP1,nP1,nP1);
% G1(i>=j) = 0; G1(j>=k) = 0;
% P = rand(nP1,nP1,nP1);
% P(i>=j) = 0; P(j>=k) = 0;
% G1(P > ratioFill3D) = NaN;
% 
% tmp = find(~isnan(G1)&G1~=0);
% [t1(:,1) t1(:,2) t1(:,3)] = ind2sub([nP1 nP1 nP1],tmp);
% t1 = int32(t1'-1);
% feat1 = G1(G1>0)';
% 
% G1 = G1+permute(G1, [1 3 2])+permute(G1, [2 1 3])+permute(G1, [2 3 1])+permute(G1, [3 1 2])+permute(G1, [3 2 1]);
% G1(i==j) = NaN; G1(k==j) = NaN; G1(k==i) = NaN;
% 
% N = deformation*randn(nP2,nP2,nP2);
% N(i>=j) = 0; N(j>=k) = 0;
% N = N+permute(N, [1 3 2])+permute(N, [2 1 3])+permute(N, [2 3 1])+permute(N, [3 1 2])+permute(N, [3 2 1]);
% 
% G2 = rand(nP2,nP2,nP2);
% G2(i>=j) = 0; G2(j>=k) = 0;
% P = rand(nP2,nP2,nP2);
% P(i>=j) = 0; P(j>=k) = 0;
% G2(P > ratioFill3D) = NaN;
% G2 = G2+permute(G2, [1 3 2])+permute(G2, [2 1 3])+permute(G2, [2 3 1])+permute(G2, [3 1 2])+permute(G2, [3 2 1]);
% G2(seq(1:nInlier),seq(1:nInlier),seq(1:nInlier)) = G1(1:nInlier,1:nInlier,1:nInlier);
% G2 = G2+N;
% 
% G2(isnan(G2))= -10;
% feat2 = G2(:)';
% 
% % G1
% % G2
% % pause
% 
% %generate features
% % t1=int32(t1);
% % [feat1,feat2] = mexComputeFeature(P1',P2',int32(t1),'simple');
% 
% %number of nearest neighbors used for each triangle (results can be bad if too low)
% nT = length(feat1);
% nNN = min(nnz(G2),500);
% % nNN=nT;
% 
% %find the nearest neighbors
% [inds, dists] = annquery(feat2, feat1, nNN, 'eps', 10);
% 
% %build the tensor
% [i j k]=ind2sub([nP2,nP2,nP2],inds);
% tmp=repmat(1:nT,nNN,1);
% 
% indH3 = t1(:,tmp(:))' + [k(:)-1 j(:)-1 i(:)-1]*nP1;
% valH3 = exp(-dists(:)/scale_3D);


%% Ground Truth
% GT.seq = seq(1:nInlier);
% GT.matrix = zeros(nP1, nP2);
% for i = 1:nInlier, GT.matrix(i,seq(i)) = 1; end
% GT.bool = GT.matrix(:);

% 
% figure(1); clf;
% hold on;
% meanAffTrue = sort(mean(M(logical(GT.bool),logical(GT.bool)),1),'descend');
% meanAffFalse = sort(mean(M(logical(GT.bool),~logical(GT.bool)),1),'descend');
% plot(meanAffTrue);
% plot(meanAffFalse);
% hold off;


%% Return results
% problem.nP1 = nP1;
% problem.nP2 = nP2;
% problem.E12 = E12;
% problem.L12 = L12;
% problem.affinityMatrix = M;
% problem.group1 = group1;
% problem.group2 = group2;
% problem.M_lin = M_lin;
% problem.M_exp = M_exp;
problem.XGT = GT.bool;
% problem.tensor_idx = indH3;
% problem.affinityTensor = valH3;
% problem.tensor_idx_full = indH3

% problem.GTbool = GT.bool;

% problem.G1 = G1;
% problem.G2 = G2;
% problem.MS = MS;


% E1 = ones(nP1,nP1) - eye(nP1);
% [edgeidx1(:,1), edgeidx1(:,2)] = find(E1);
% gphs{1}.G = edgeidx2G(edgeidx1,nP1);
% gphs{1}.H = [gphs{1}.G, eye(nP1)];
% E2 = ones(nP2,nP2) - eye(nP2);
% [edgeidx2(:,1), edgeidx2(:,2)] = find(E2);
% gphs{2}.G = edgeidx2G(edgeidx2,nP2);
% gphs{2}.H = [gphs{2}.G, eye(nP2)];

% problem.KP = zeros(nP1,nP2);
% problem.KQ = G2KQ(G1,G2,E1,E2,scale_2D);
% problem.Ct = ones(nP1,nP2);
% problem.gphs = gphs;
% problem.asgT.alg = 'truth';
% problem.asgT.X = GT.matrix;

% writeFile(problem);