function [ problem ] = makeGraphMatchingProblem( Set )
%% Extract all variables from Set
strNames = fieldnames(Set);
for i = 1:length(strNames), eval([strNames{i} '= Set.' strNames{i} ';']); end
%% Set number of nodes
if bOutBoth, nP1 = nInlier + nOutlier; else nP1 = nInlier; end
nP2 = nInlier + nOutlier;
%% Generate two graps
% GT sequence 
if bPermute, seq = randperm(nP2); else seq = 1:nP2; end
% Generate graph 1 
G1 = tril(rand(nP1),-1); % lower triangular graph
G1 = G1+G1';
P = tril(rand(nP1),-1);
P = P+P';
P = P > ratioFill;
G1(P) = NaN;

m = 2; %number of graphs
problem.m=2;
nP2=2*nP2;
% seq = randperm(nP2);

N = deformation*tril(randn(nP2),-1);
N = N+N';


%when there are outliers we have to create it 
%the inliers will be substituted by copying G1
G2 = tril(rand(nP2),-1);
%to make it symetric (and positive semidefinite)
G2 = G2+G2';
P = tril(rand(nP2),-1);
P = P+P';
P = P > ratioFill;
G2(P) = NaN;
%copying Graph 1 to Graph 2 (but only inliers)
G2(seq(1:nInlier),seq(1:nInlier)) = G1(1:nInlier,1:nInlier);
G2(seq(1:nInlier)+nP2/2,seq(1:nInlier)+nP2/2) = G1(1:nInlier,1:nInlier);
% G2(seq((1:nInlier)+nP2/2),seq((1:nInlier)+nP2/2)) = G1(1:nInlier,1:nInlier);
%and perturbing it with noise
G2 = G2+N;

E12 = ones(nP1,nP2);
[L12(:,1) L12(:,2)] = find(E12);
[group1 group2] = make_group12(L12);
    
%after generating two graphs we create affinity matrix where affinity is
%calculated as similarity
%repeat G1(20x20) nP2 (20) times nP1 (20) times to get 400x400
%take each value from G2 and copy it to the size nP1xnP1
%here first bigger number means less similarity
M = (repmat(G1, nP2, nP2)-kron(G2,ones(nP1))).^2;

%we change to do inverse, bigger number means more affinity
M = exp(-M./scale_2D);
M(isnan(M)) = 0;
M(1:(length(M)+1):end)=0;
M = M+M';

%M = repmat(M, m, m);
%M(length(M)/m+1:length(M),1:length(M)/m)=zeros(1:length(M)/m, 1:length(M)/m);
%M(1:length(M)/m,length(M)/m+1:length(M))=zeros(1:length(M)/m, 1:length(M)/m);






%% graph variables for Factorized Graph Matching
% edge map for fully connected graph
E1 = [];
for j = 1:length(G1)-1
    for i = j+1:length(G1)
        E1 = [E1; j i];
    end
end
E2 = [];
for j = 1:length(G2)-1
    for i = j+1:length(G2)
        E2 = [E2; j i];
    end
end
% construct node by edge relation map
H1 = zeros(length(G1), length(E1));
for i = 1:length(E1)
    H1(E1(i,1),i) = 1;
    H1(E1(i,2),i) = 1;
end
H2 = zeros(length(G2), length(E2));
for i = 1:length(E2)
    H2(E2(i,1),i) = 1;
    H2(E2(i,2),i) = 1;
end

Kp = zeros(nP1, nP2);
Kq = zeros(length(E1), length(E2));
Kq2 = zeros(length(E1), length(E2));
for j = 1:length(E1)
    e1 = G1(E1(j,1),E1(j,2));
    for i = 1:length(E2)
        e2 = G2(E2(i,1),E2(i,2));
        Kq(j,i) = exp(-((e1-e2)^2)/scale_2D);
        Kq2(j,i) = e1*e2;
%         Kq(j,i) = e1*e2;
    end
end



KPP = 0;
KQQ = zeros(size(E1,1),size(E2,1));
for i = 1 : size(E1,1)
    for j = 1 : size(E2,1)
        m1 = E1(i,1) + (E2(j,1)-1)*nP1;
        m2 = E1(i,2) + (E2(j,2)-1)*nP1;
        KQQ(i,j) = M(m1,m2)/2;
    end
end

for i = 1 : size(E1,1)
    for j = 1 : size(E2,1)
        m1 = E1(i,1) + (E2(j,1)-1)*nP1;
        m2 = E1(i,2) + (E2(j,2)-1)*nP1;
        MM(m1,m2) = Kq(i,j);
    end
end




% Kq
% M
% 
% unique(Kq(:))
% unique(M(:))
% 
% H1
% H2
L = [Kq -Kq*H2'; -H1*Kq H1*Kq*H2'];
L2 = [Kq2 -Kq2*H2'; -H1*Kq2 H1*Kq2*H2'];

gphs{1}.G = H1;
gphs{2}.G = H2;

H1 = [H1 eye(length(G1))];
H2 = [H2 eye(length(G2))];

gphs{1}.H = H1;
gphs{2}.H = H2;


%% SVD of Kq
nAdj = rank(L);
[U, S, V] = svd(L);
% diag(S)
% U(:,1:5)
% V(:,1:5)

U = U(:,1:nAdj);
V = V(:,1:nAdj);
for k = 1:nAdj
    U(:,k) = U(:,k)*sqrt(S(k,k));
    V(:,k) = V(:,k)*sqrt(S(k,k));
end

T = U(:,1)*V(:,1)';
for k = 2:nAdj
    T = T + U(:,k)*V(:,k)';
end
% T

%% new Adj matrix generation
for k = 1:nAdj
    A1{k} = H1*diag(U(:,k))*H1';
    A2{k} = H2*diag(V(:,k))*H2';
    
%     A1{k}(A1{k} < 0) = 0;
%     A2{k}(A2{k} < 0) = 0;
end

%% SVD of Kq
nAdj = rank(L2);
[U, S, V] = svd(L2);
% diag(S)
% U(:,1:5)
% V(:,1:5)

U = U(:,1:nAdj);
V = V(:,1:nAdj);
for k = 1:nAdj
    U(:,k) = U(:,k)*sqrt(S(k,k));
    V(:,k) = V(:,k)*sqrt(S(k,k));
end

T = U(:,1)*V(:,1)';
for k = 2:nAdj
    T = T + U(:,k)*V(:,k)';
end
% T

%% new Adj matrix generation
for k = 1:nAdj
    B1{k} = H1*diag(U(:,k))*H1';
    B2{k} = H2*diag(V(:,k))*H2';
    
%     A1{k}(A1{k} < 0) = 0;
%     A2{k}(A2{k} < 0) = 0;
end

% %% Validation
% while 0
% %     X = ones(size(A1{1},1), size(A2{1},1));
%     X = rand(size(A1{1},1), size(A2{1},1));
%     x = X(:);
%     
% %     S = 0;
% %     for k = 1:nAdj
% %         S = S + trace(A1{k}*X*A2{k}*X');
% %     end
% %     s = x'*M*x;
%     
%     [S s S/s]
%     pause
% end

% M = zeros(nP1*nP2);
% for j = 1:length(M)-1
%     for i = j+1:length(M)
%         if isnan( G1(L12(j,1),L12(i,1)) ) || isnan( G2(L12(j,2),L12(i,2)) )
%             M(j,i) = 0;
%         else
%             M(j,i) = exp(-(G1(L12(j,1),L12(i,1))-G2(L12(j,2),L12(i,2)))^2/scale_2D);
%         end
%     end
% end

% %% 3rd Order Tensor
% [i j k] = ind2sub([nP1 nP1 nP1], 1:nP1^3);
% G1 = rand(nP1,nP1,nP1);
% % G1 = ratioFill3D*rand(nP1,nP1,nP1)/0.3;
% G1(i>=j) = 0; G1(j>=k) = 0;
% P = rand(nP1,nP1,nP1);
% P(i>=j) = 0; P(j>=k) = 0;
% G1(P > ratioFill3D) = NaN;
% 
% tmp = find(~isnan(G1)&G1~=0);
% [t1(:,1) t1(:,2) t1(:,3)] = ind2sub([nP1 nP1 nP1],tmp);
% t1 = int32(t1'-1);
% feat1 = G1(G1>0)';
% 
% G1 = G1+permute(G1, [1 3 2])+permute(G1, [2 1 3])+permute(G1, [2 3 1])+permute(G1, [3 1 2])+permute(G1, [3 2 1]);
% G1(i==j) = NaN; G1(k==j) = NaN; G1(k==i) = NaN;
% 
% N = deformation*randn(nP2,nP2,nP2);
% N(i>=j) = 0; N(j>=k) = 0;
% N = N+permute(N, [1 3 2])+permute(N, [2 1 3])+permute(N, [2 3 1])+permute(N, [3 1 2])+permute(N, [3 2 1]);
% 
% G2 = rand(nP2,nP2,nP2);
% % G2 = ratioFill3D*rand(nP2,nP2,nP2)/0.3;
% G2(i>=j) = 0; G2(j>=k) = 0;
% P = rand(nP2,nP2,nP2);
% P(i>=j) = 0; P(j>=k) = 0;
% G2(P > ratioFill3D) = NaN;
% G2 = G2+permute(G2, [1 3 2])+permute(G2, [2 1 3])+permute(G2, [2 3 1])+permute(G2, [3 1 2])+permute(G2, [3 2 1]);
% G2(seq(1:nInlier),seq(1:nInlier),seq(1:nInlier)) = G1(1:nInlier,1:nInlier,1:nInlier);
% G2 = G2+N;
% 
% G2(isnan(G2))= -10;
% feat2 = G2(:)';
% 
% % G1
% % G2
% % pause
% 
% %generate features
% % t1=int32(t1);
% % [feat1,feat2] = mexComputeFeature(P1',P2',int32(t1),'simple');
% 
% %number of nearest neighbors used for each triangle (results can be bad if too low)
% nT = length(feat1);
% nNN = min(nnz(G2),500);
% % nNN=nT;
% 
% %find the nearest neighbors
% [inds, dists] = annquery(feat2, feat1, nNN, 'eps', 10);
% 
% %build the tensor
% [i j k]=ind2sub([nP2,nP2,nP2],inds);
% tmp=repmat(1:nT,nNN,1);
% 
% indH3 = t1(:,tmp(:))' + [k(:)-1 j(:)-1 i(:)-1]*nP1;
% valH3 = exp(-dists(:)/scale_3D);


%% Ground Truth
GT.seq = seq(1:nInlier);
GT.seq2 = seq(1:nInlier)+length(G1); %%v%%
% GT.seq2 = seq((1:nInlier)+length(G1)); %%v%%

GT.matrix = zeros(nP1, nP2);
GT.matrix2 = zeros(nP1, nP2); %%v%%

for i = 1:nInlier, GT.matrix(i,seq(i)) = 1; end
for i = 1:nInlier, GT.matrix2(i,GT.seq2(i)) = 1; end %%v%%

GT.bool = GT.matrix(:);
GT.bool2 = GT.matrix2(:); %%v%%
find(GT.bool>0.3)
find(GT.bool2>0.3) %%v%%


%% Return results
problem.nP1 = nP1;
problem.nP2 = nP2;
problem.E12 = E12; %in the case of noise experiments it always consists of 1s
problem.L12 = L12;
problem.affinityMatrix = M;
problem.group1 = group1;
problem.group2 = group2;%%v%%

problem.GTbool = GT.bool;
problem.GTbool2 = GT.bool2; %%v%%

%FGM results

problem.H1 = H1;
problem.H2 = H2;
problem.Kp = Kp;
problem.Kq = Kq;
problem.Kq2 = Kq2;
problem.gphs = gphs;
problem.asgT = [];

par.nAlp = 100;
par.nItMa = 100;
par.nHst = 10;
par.ip = 'y';
par.thAlp = 0;
par.deb = 'n';
par.idxAlp = [];
problem.par = par;

problem.A1 = A1;
problem.A2 = A2;
problem.B1 = B1;
problem.B2 = B2;



