function [ problem ] = makeGraphMatchingProblem( Set )
%% Extract all variables from Set
strNames = fieldnames(Set);
for i = 1:length(strNames), eval([strNames{i} '= Set.' strNames{i} ';']); end
%% Set number of nodes
if bOutBoth, nP1 = nInlier + nOutlier; else nP1 = nInlier; end
nP2 = nInlier + nOutlier;
%% Generate two graps
% GT sequence 
if bPermute, seq = randperm(nP2); else seq = 1:nP2; end
% Generate graph 1 
G1 = tril(rand(nP1),-1); % lower triangular graph
G1 = G1+G1';
P = tril(rand(nP1),-1);
P = P+P';
P = P > ratioFill;
G1(P) = NaN;

m = 2; %number of graphs
problem.m=2;
%nP2=2*nP2;

N = deformation*tril(randn(2*nP2),-1);
N = N+N';


%when there are outliers we have to create it 
%the inliers will be substituted by copying G1
G2 = tril(rand(2*nP2),-1);
%to make it symetric (and positive semidefinite)
G2 = G2+G2';
P = tril(rand(2*nP2),-1);
P = P+P';
P = P > ratioFill;
G2(P) = NaN;
%copying Graph 1 to Graph 2 (but only inliers)
G2(seq(1:nInlier),seq(1:nInlier)) = G1(1:nInlier,1:nInlier);
G2(seq(1:nInlier)+nP2,seq(1:nInlier)+nP2) = G1(1:nInlier,1:nInlier);
%and perturbing it with noise
G2 = G2+N;

E12 = ones(nP1,nP2);
[L12(:,1) L12(:,2)] = find(E12);
[group1 group2] = make_group12(L12);
    
%after generating two graphs we create affinity matrix where affinity is
%calculated as similarity
%repeat G1(20x20) nP2 (20) times nP1 (20) times to get 400x400
%take each value from G2 and copy it to the size nP1xnP1
%here first bigger number means less similarity
M = (repmat(G1, 2*nP2, 2*nP2)-kron(G2,ones(nP1))).^2;

%we change to do inverse, bigger number means more affinity
M = exp(-M./scale_2D);
M(isnan(M)) = 0;
M(1:(length(M)+1):end)=0;
M = M+M';

%M = repmat(M, m, m);
%M(length(M)/m+1:length(M),1:length(M)/m)=zeros(1:length(M)/m, 1:length(M)/m);
%M(1:length(M)/m,length(M)/m+1:length(M))=zeros(1:length(M)/m, 1:length(M)/m);

%% Ground Truth
GT.seq = seq(1:nInlier);
GT.seq2 = seq(1:nInlier)+length(G1); %%v%%

GT.matrix = zeros(nP1, nP2);
GT.matrix2 = zeros(nP1, nP2); %%v%%

for i = 1:nInlier, GT.matrix(i,seq(i)) = 1; end
for i = 1:nInlier, GT.matrix2(i,GT.seq2(i)) = 1; end %%v%%

GT.bool = GT.matrix(:);
GT.bool2 = GT.matrix2(:); %%v%%
find(GT.bool>0.3)
find(GT.bool2>0.3) %%v%%


%% Return results
problem.nP1 = nP1;
problem.nP2 = nP2;
problem.E12 = E12;
problem.L12 = L12;
problem.affinityMatrix = M;
problem.group1 = group1;
problem.group2 = group2;%%v%%

problem.GTbool = GT.bool;
problem.GTbool2 = GT.bool2; %%v%%



