%% Makes current problem into Graph Matching form
function [accuracy score time groundTruth groundTruthScore permO X Xraw] = wrapper_GM(method, cdata)
% Make function evaluation script
str = ['feval(@' func2str(method.fhandle)];
for j = 1:length(method.variable), str = [str ',cdata.' method.variable{j} ]; end
if ~isempty(method.param), for i = 1:length(method.param), str = [str, ',method.param{' num2str(i) '}']; end; end
str = [str, ')']; 
% Function evaluation & Excution time Check
tic; 

if ~strcmp(method.strName,'Proposed (discrete)')
Xraw = eval(str);
if strcmp(method.strName,'Proposed')
    save('TBcomp.mat', 'Xraw'); 
end
else
Xraw=cell2mat(struct2cell(load('TB.mat')));
end

str
if ~strcmp(str,'feval(@RRWM,cdata.affinityMatrix,cdata.group1,cdata.group2)')
   permBeforeDiscretization=find(Xraw>0.00001)
end;
Xraw=Xraw(:);
scoreRaw = Xraw'*cdata.affinityMatrix*Xraw/2 % objective score function
time = toc;
% Discretization by one-to-one mapping constraints
% if strcmp(func2str(method.fhandle),'TBMA3')
%     X=discretization(Xraw, cdata.affinityMatrix);
% elseif 1
if ~strcmp(method.strName,'Proposed')
    % Hungarian assignment
    X = zeros(size(cdata.E12)); X(find(cdata.E12)) = Xraw;
    X = discretisationMatching_hungarian(X,cdata.E12); X = X(find(cdata.E12));
 else % Greedy assignment
%     X = greedyMapping(Xraw, cdata.group1, cdata.group2);
      X = Xraw;
end
indexesOfMatches=find(X>0.5); %VIMP
% Matching Score
score = X'*cdata.affinityMatrix*X/2 % objective score function %VIP
if length(cdata.GTbool) ~= length(cdata.affinityMatrix)
    accuracy = NaN; % Exception for no GT information
else
    accuracy = (X(:)'*cdata.GTbool(:))/sum(cdata.GTbool);
    if strcmp(func2str(method.fhandle),'TBMA3') & accuracy ~= 1
        carramba=1;
    end
end

groundTruth=find(cdata.GTbool(:)>0.4);
groundTruthScore = cdata.GTbool(:)'*cdata.affinityMatrix*cdata.GTbool(:); % objective score function

permO=find(X>0.4)

if ~strcmp(str,'feval(@RRWM,cdata.affinityMatrix,cdata.group1,cdata.group2)')
difference=setxor(permBeforeDiscretization,permO)
end;

nodesNum=length(permO);
alphaO=zeros(nodesNum, 1); %sum of nodes inside the clique
for i=1:nodesNum
         alphaO(i)=sum(cdata.affinityMatrix(permO(i),permO));
         %betaO(i)=sum(aff(i,permO(k+1:nodesNum)));
end;
str; %VIMP
weightsSum=sum(alphaO)/2; %VIMP