%% Makes current problem into Graph Matching form
function [accuracy score time groundTruth groundTruthScore accuracyMat permO X Xraw] = wrapper_GM(method, cdata)
% Make function evaluation script
str = ['feval(@' func2str(method.fhandle)];
for j = 1:length(method.variable)
    str = [str ',cdata.' method.variable{j} ]; 
end
if ~isempty(method.param),
    for i = 1:length(method.param),
        str = [str, ',method.param{' num2str(i) '}']; 
    end;
end
str = [str, ')']; 

originalMatrix=cdata.affinityMatrix;

Xsoldisc=zeros(length(cdata.affinityMatrix), 2);

% Function evaluation & Excution time Check
tic; 
if strcmp(method.strName, 'Proposed') | strcmp(method.strName, 'SEA')
    [Xraw, Xsol] = eval(str);
    Xsoldisc=Xsol;
else

    for iii=1:2
    [Xraw] = eval(str);  
    


    % Discretization by one-to-one mapping constraints
    %if strcmp(func2str(method.fhandle),'TBMA')
    %    X=discretization(Xraw, cdata.affinityMatrix);
    %elseif 1
    %     Xsoldisc=zeros(size(Xsol,1),size(Xsol,2));
    if ~strcmp(method.strName, 'Proposed')
         % Hungarian assignment
        X = zeros(size(cdata.E12)); X(find(cdata.E12)) = Xraw;
        X = discretisationMatching_hungarian(X,cdata.E12); X = X(find(cdata.E12));
        Xsoldisc(:, iii)=X;
    elseif ~strcmp(method.strName, 'Proposed')
        % Hungarian assignment
         for i=1:cdata.m
            %X = zeros(size(cdata.E12)); X(find(cdata.E12)) = Xraw;
            X = zeros(size(cdata.E12)); X(find(cdata.E12)) = Xsol(:,i);
            X = discretisationMatching_hungarian(X,cdata.E12); Xsoldisc(:,i) = X(find(cdata.E12));
         end   

    %else % Greedy assignment
    %    X = greedyMapping(Xraw, cdata.group1, cdata.group2);
    end

    
    
    
    
    inoutliers=15; %(iniers and outliers)
%     
    Xaff=cdata.affinityMatrix;
% 
    indexes=find(X>0.5);
    ydim=mod(indexes, inoutliers);
    ydim(ydim==0)=inoutliers;
    xdim=ceil(indexes/inoutliers);
% 
% 
%     diffx=setxor(xdim, xdimapp)
%     diffy=setxor(ydim, ydimapp)
% 
% 
% 
    xdimupperbound=xdim*inoutliers;
    ydimupperbound=ydim*inoutliers;
% 
% 
% 
    for i=1:inoutliers
       Xaff((xdimupperbound(i)-inoutliers+1): xdimupperbound(i), :)=0; 
       Xaff(:, (ydimupperbound(i)-inoutliers+1): ydimupperbound(i))=0; 
    end
% 
      cdata.affinityMatrix=Xaff;
end;

cdata.affinityMatrix=originalMatrix;

end
time = toc;
%[ind2 ind3] = find(Xaff>-1000);
%Xaff(indices) = NaN;  

%X=Xraw;



% Matching Score
%score = X'*cdata.affinityMatrix*X; % objective score function
score=0;

accuracyMat=zeros(cdata.m,1);

if length(cdata.GTbool) ~= length(cdata.affinityMatrix)
    accuracy = NaN; % Exception for no GT information
else
  
    %we have two our solutions and two ground truth solutions
    %we need match them:
    accuracy1 = (Xsoldisc(:, 1)'*cdata.GTbool(:))/sum(cdata.GTbool);
    accuracy2 = (Xsoldisc(:, 1)'*cdata.GTbool2(:))/sum(cdata.GTbool2);
    accuracyA = max(accuracy1,accuracy2);
    
    accuracy1 = (Xsoldisc(:, 2)'*cdata.GTbool(:))/sum(cdata.GTbool);
    accuracy2 = (Xsoldisc(:, 2)'*cdata.GTbool2(:))/sum(cdata.GTbool2);
    accuracyB = max(accuracy1,accuracy2);
    
    accuracyMat(1)=accuracyA;
    accuracyMat(2)=accuracyB
    
    accuracy=(accuracyA+accuracyB)/2;
    
    
    
    %accuracy = (X(:)'*cdata.GTbool(:))/sum(cdata.GTbool);

end

groundTruth=find(cdata.GTbool(:)>0.4);
groundTruthScore = cdata.GTbool(:)'*cdata.affinityMatrix*cdata.GTbool(:); % objective score function

score1 = Xsoldisc(:, 1)'*cdata.affinityMatrix*Xsoldisc(:, 1)/2; % objective score function
score2 = Xsoldisc(:, 2)'*cdata.affinityMatrix*Xsoldisc(:, 2)/2; % objective score function
score=(score1+score2)/2;

% permO=find(X>0.4);
% nodesNum=length(permO);
% alphaO=zeros(nodesNum, 1); %sum of nodes inside the clique
% for i=1:nodesNum
%          alphaO(i)=sum(cdata.affinityMatrix(permO(i),permO));
%          %betaO(i)=sum(aff(i,permO(k+1:nodesNum)));
% end;
% str
% weightsSum=sum(alphaO)/2